import { Utilities } from '@/util/Utilities';
import {
Form, LoadingService, Modal, ModalService, SelectMultiple,
} from '@zeedhi/common';
import { Http, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class TabFranchisedController {
    private modalAddFranchised!: Modal;

    public async abrirModalAddOrganizacoes() {
        this.modalAddFranchised = await ModalService.createFromJson('sources/BusinessPartner/Modal/modal-add-franchised', true);
        this.modalAddFranchised.show();
    }

    public closeModalAddOrganizacoes() {
        this.modalAddFranchised.hide();
        this.modalAddFranchised?.destroy();
    }

    public adicionarFranquiadas() {
        const gridFranchised = Metadata.getInstance<TekGrid>('tekGrid-tabFranchised');
        const gridBusinessPartner = Metadata.getInstance<TekGrid>('gridBusinessPartner');
        const parceiros = Metadata.getInstance<SelectMultiple>('formAddFranchised-NRPARCNEGOCIO');
        const form = Metadata.getInstance<Form>('formAddFranchised');
        if (form.validate()) {
            LoadingService.show();
            Http.post('/associateOrganizations', {
                FRANQUIA: gridBusinessPartner.datasource.currentRow.NRPARCNEGOCIO,
                PARCEIROS: parceiros.selectValue,
            }).then(() => {
                Utilities.showSuccessMessage();
                gridFranchised.datasource.get();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                this.closeModalAddOrganizacoes();
                LoadingService.hide();
            });
        } else {
            Utilities.showAlertMessage('Preencha todos os campos obrigatórios (*)!', 'error');
        }
    }
}
